
%% LOAD 
clc; clear all;close all;
%input_file = input('filename:','s');
input_file = ('AD_COMs');
load(input_file)

do_LP_filter = 1;
calculate_RP = 0;
do_INTEGRATE = 1;
do_PLOT = 1;
do_NET_CURRENT = 0;
do_COMPARE_2MA_PR = 0;
do_CATHODIC_AVRG = 0;

if do_CATHODIC_AVRG
   avg_data = zeros(6,6);
    % Structure
    % 1 Row top value
    
    q1=data_2ma_22nF.';
    q2=data_2ma_100nF.';
    q3=data_2ma_220nF.';
    q4=data_2ma_470nF.';
    q5=data_2ma_680nF.';
    q6=data_2ma_4700nF.';
    
    avg_data(1,1) = mean(q1(33455:33938));
    avg_data(1,2) = mean(q2(33455:33938));
    avg_data(1,3) = mean(q3(33455:33938));
    avg_data(1,4) = mean(q4(33455:33938));
    avg_data(1,5) = mean(q5(33455:33938));
    avg_data(1,6) = mean(q6(33455:33938));
end

if do_LP_filter
    % set values
    GS_FAC = 39;
    AVG = 1;
    GAUSS = 1;
    
    data_2ma_22nF = LP_filter(data_2ma_22nF,GS_FAC,AVG,GAUSS);
    data_2ma_100nF = LP_filter(data_2ma_100nF,GS_FAC,AVG,GAUSS);
    data_2ma_220nF = LP_filter(data_2ma_220nF,GS_FAC,AVG,GAUSS);
    data_2ma_470nF = LP_filter(data_2ma_470nF,GS_FAC,AVG,GAUSS);
    data_2ma_680nF = LP_filter(data_2ma_680nF,GS_FAC,AVG,GAUSS);
    data_2ma_4700nF = LP_filter(data_2ma_4700nF,GS_FAC,AVG,GAUSS);
end

if calculate_RP
    rp_data = zeros(6,6);
    % Structure
    % 1 Row top value
    rp_data(1,1) = max(data_2ma_22nF);
    rp_data(1,2) = max(data_2ma_100nF);
    rp_data(1,3) = max(data_2ma_220nF);
    rp_data(1,4) = max(data_2ma_470nF);
    rp_data(1,5) = max(data_2ma_680nF);
    rp_data(1,6) = max(data_2ma_4700nF);
    
    % 2 Row index top value
    rp_data(2,1) = find(data_2ma_22nF==rp_data(1,1),1);
    rp_data(2,2) = find(data_2ma_100nF==rp_data(1,2),1);
    rp_data(2,3) = find(data_2ma_220nF==rp_data(1,3),1);
    rp_data(2,4) = find(data_2ma_470nF==rp_data(1,4),1);
    rp_data(2,5) = find(data_2ma_680nF==rp_data(1,5),1);
    rp_data(2,6) = find(data_2ma_4700nF==rp_data(1,6),1);
    
    % 3 Row 63.2% value
    for i = 1:6
        rp_data(3,i) = 0.632*rp_data(1,i)
    end
    
    % 4 Row index 36.8% value
    [~, rp_data(4,1)] = min(abs(data_2ma_22nF-rp_data(3,1)));
    [~, rp_data(4,2)] = min(abs(data_2ma_100nF-rp_data(3,2)));
    [~, rp_data(4,3)] = min(abs(data_2ma_220nF-rp_data(3,3)));
    [~, rp_data(4,4)] = min(abs(data_2ma_470nF-rp_data(3,4)));
    [~, rp_data(4,5)] = min(abs(data_2ma_680nF-rp_data(3,5)));
    [~, rp_data(4,6)] = min(abs(data_2ma_4700nF-rp_data(3,6)));
    
    
    % 5 Row Capacitor value
    rp_data(5,1) = 22*(10^-9);
    rp_data(5,2) = 100*(10^-9);
    rp_data(5,3) = 220*(10^-9);
    rp_data(5,4) = 470*(10^-9);
    rp_data(5,5) = 680*(10^-9);
    rp_data(5,6) = 4700*(10^-9);
    

    % 6 Row RP value
    for i = 1:6
        tau = (rp_data(4,i)-rp_data(1,i))*(10^-6);
        r = tau/rp_data(5,i)
        rp_data(6,i) = r;
    end
    
    % plot it
    fig2 = figure(2);
    bar(rp_data(6,:)');xlabel(['Load capacitance 22-4700 [nF]']); ylabel('Out. imp. [k\ohm]');
    

end
    

%% Compare
if do_COMPARE_2MA_PR
    load('AD_PR.mat')
    if do_LP_filter
        data_2ma = LP_filter(data_2ma,GS_FAC,AVG,GAUSS);
    end
end
    

if do_INTEGRATE
        n = length(data_2ma_4700nF);
        [i_1, i_2, i_3, i_4, i_5, i_6, i_7]= deal(zeros(1,length(n)));
    
    downscale = 1;
    for i = 1:n
        i_1(i) = sum(data_2ma_22nF(1:i))*downscale;
        i_2(i) = sum(data_2ma_100nF(1:i))*downscale;
        i_3(i) = sum(data_2ma_220nF(1:i))*downscale;
        i_4(i) = sum(data_2ma_470nF(1:i))*downscale;
        i_5(i) = sum(data_2ma_680nF(1:i))*downscale;
        i_6(i) = sum(data_2ma_4700nF(1:i))*downscale;
        %i_7(i) = sum(data_2ma(1:i))*downscale;
    end
    
        integrals(1) = i_1(end);
        integrals(2) = i_2(end);
        integrals(3) = i_3(end);
        integrals(4) = i_4(end);
        integrals(5) = i_5(end);
        integrals(6) = i_6(end);

end
    


if do_PLOT
%% Prelim Plot
    ts = 1000000;
    scale = 1e6; % scale for useconds
    tps = 1/ts;
    n = length(data_2ma_100nF);
    time = ones(1,n);
    time = time'.*tps;
   

    % axis data
    precision = 6;
    x_scale = num2str(tps*scale,precision);
    y_scale = 1000; % scale from mA to uA

    fig1 = figure(1);
    subplot(3,1,1);
    hold on;
    grid on;
    a1 = plot(y_scale*data_2ma_22nF, 'b');  M1 = '  22 nF'; 
    a2 = plot(y_scale*data_2ma_100nF,'g');  M2 = ' 100 nF';
    a3 = plot(y_scale*data_2ma_220nF,'c');  M3 = ' 220 nF';
    a4 = plot(y_scale*data_2ma_470nF,'r');  M4 = ' 470 nF';
    a5 = plot(y_scale*data_2ma_680nF,'m');  M5 = ' 680 nF';
    a6 = plot(y_scale*data_2ma_4700nF,'k'); M6 = '4700 nF';
    %a7 = plot(y_scale*data_2ma,'b','LineWidth',2);        M7 = 'PR load';
   
    
    xlabel(['Time [',x_scale,' us]']); ylabel('Current [uA]');
    title('(a) {\bf Anodic phase | Capacitive load | 22 - 4700 nF}')
    legend([a1; a2; a3; a4; a5; a6], [M1; M2; M3; M4; M5; M6]);
   % set(findall(fig1,'type','text'),'fontSize',16,'fontWeight','bold')
   
 
   % fig2 = figure(2);
    
    subplot(3,1,3);
     hold on;
      grid on;
    a1 = plot(y_scale*data_2ma_22nF, 'b');  M1 = '  22 nF'; 
    a2 = plot(y_scale*data_2ma_100nF,'g');  M2 = ' 100 nF';
    a3 = plot(y_scale*data_2ma_220nF,'c');  M3 = ' 220 nF';
    a4 = plot(y_scale*data_2ma_470nF,'r');  M4 = ' 470 nF';
    a5 = plot(y_scale*data_2ma_680nF,'m');  M5 = ' 680 nF';
    a6 = plot(y_scale*data_2ma_4700nF,'k'); M6 = '4700 nF';
    %a7 = plot(y_scale*data_2ma,'b','LineWidth',2);        M7 = 'PR load';
   
    
    xlabel(['Time [',x_scale,' us]']); ylabel('Current [uA]');
    title('(b) {\bf Cathodic phase | Capacitive load | 22 - 4700 nF}')
    %legend([a1; a2; a3; a4; a5; a6], [M1; M2; M3; M4; M5; M6]);
    
       if do_INTEGRATE
         subplot(3,1,2);
         hold on;
         grid on;
        plot(i_1,'b--');
        plot(i_2,'g--');
        plot(i_3,'c--');
        plot(i_4,'r--');
        plot(i_5,'m--');
        plot(i_6,'k--');
       % plot(i_7,'b--','LineWidth',2);
       xlabel(['Time [',x_scale,' us]']); ylabel('Charge [nC]');
    title('(c) {\bf Signal integral | Capacitive load | 22 - 4700 nF}')
    end
    
    
    
    
    
end



%% CALCULATE

if do_NET_CURRENT
    net_current(1,1) = sum(data_2ma_22nF);
    net_current(1,2) = sum(data_2ma_100nF);
    net_current(1,3) = sum(data_2ma_220nF);
    net_current(1,4) = sum(data_2ma_470nF);
    net_current(1,5) = sum(data_2ma_680nF);
    net_current(1,6) = sum(data_2ma_4700nF);
    save(input_file,'net_current','-append');
end