clc; clear all;close all;
load('data');

%% Toggle 

do_RAW = 0;
do_RC_ESTIMATE = 0;
do_PLOT_INTEGRATION = 1;
do_NET_DC = 1;



charge = sum(cut_data((33445:33958),:));
for i = 2:14
    charge(2,i) = charge(1,i)-charge(1,i-1);
end
cc=hsv(12);
fig4 = figure(4);
hold on;
grid on;
subplot(2,2,1);
bar(abs(charge));
ylabel('Charge [nC]');
set(gca,'XTickLabel',{'(a)', '(b)'})
title('{\bf Cathodic charge 0.25 - 3.5 mA}')

subplot(2,2,2);
b1 = bar(abs(charge(2,:)));
grid on;
ylabel('Charge [nC]');
title('{\bf Charge increment 0.25 - 3.5 mA (1-14)}')

%set(gca,'XTickLabel',{'(a) Cathodic charge', '(b) Charge increment'})
%title('{\bf Cathodic charge for 0.25 - 3.5 mA}')

 int_end = integral(end,:);
 subplot(2,2,[3 4]);
 bar(int_end)
 grid on;
 title('{\bf Net charge for group 3 (1.75 - 3.5 mA)}')
 ylabel('Charge [nC]');



%% Plot axis
X_MIN = 0;
%X_MAX = n;
X_MAX = 50000;

%Y_MIN = 0;
Y_MIN = -3500;
Y_MAX = 100;

%% LP filtering

lp_data = zeros(n,nd);
GS_FAC = 3;
AVG = 9;
GAUSS = 9;


for i = 1:nd
    lp_data(:,i) = LP_filter(cut_data(:,i),GS_FAC,AVG,GAUSS);
end

%% Net DC

if do_NET_DC
    for i = 1:nd
        net_dc(:,i) = mean(cut_data(:,i));
    end
end



%% Plot filtered data

ts = 1000000;
xscale = 1e6; % scale for useconds
yscale = 1e3; % scale for micro ampere
tps = 1/ts;
time = ones(1,n);
time = time'.*tps;

% axis data
precision = 6;
x_scale = num2str(tps*xscale,precision);
y_scale = num2str(yscale,precision);


fig1 = figure(1);
ha(1)=subplot(2,1,1);
set(fig1,'OuterPosition',[-1927 -7 1936 1216]);
axis([X_MIN X_MAX Y_MIN Y_MAX]);
hold on;
grid on;

a1=plot(yscale*lp_data(:,1),'r');M1 = '0.25 mA';
a2=plot(yscale*lp_data(:,2),'g');M2 = '0.50 mA';
a3=plot(yscale*lp_data(:,3),'b');M3 = '0.75 mA';
a4=plot(yscale*lp_data(:,4),'k');M4 = '1.00 mA';

a5=plot(yscale*lp_data(:,5),'r');M5 = '1.25 mA';
a6=plot(yscale*lp_data(:,6),'g');M6 = '1.50 mA';
a7=plot(yscale*lp_data(:,7),'b');M7 = '1.75 mA';     
a8=plot(yscale*lp_data(:,8),'k');M8 = '2.00 mA';   


a9=plot(yscale*lp_data(:,9),'r');M9 = '2.25 mA';    
a10=plot(yscale*lp_data(:,10),'g');M10 = '2.50 mA';   
a11=plot(yscale*lp_data(:,11),'b');M11 = '2.75 mA';     
a12=plot(yscale*lp_data(:,12),'k');M12 = '3.00 mA';

a13=plot(yscale*lp_data(:,13),'c');M13 = '3.25 mA'; 
a14=plot(yscale*lp_data(:,14),'g');M14 = '3.50 mA';

xlabel(['Time [',x_scale,' us]']); ylabel('Current [uA]');
title('(a) {\bf Anodic phase | Resistive 3kOhm Load | 0.25 - 3.5 mA}')

legend([a1; a2; a3; a4; a5; a6; a7; a8; a9; a10; a11; a12; a13; a14], [M1; M2; M3; M4; M5; M6; M7; M8; M9; M10; M11; M12; M13; M14],'Orientation', 'vertical');

if do_PLOT_INTEGRATION
    % Plot integration
    ds = 1; % downscale factor
    ha(2)=subplot(2,1,2);
    % fig2 = figure(2);
    hold on;
    grid on;
    a1 = plot(ds*integral(:,1),'r--'); M1 = '0.25 mA';
    a2 = plot(ds*integral(:,2),'g--'); M2 = '0.50 mA';
    a3 = plot(ds*integral(:,3),'b--'); M3 = '0.75 mA';
    a4 = plot(ds*integral(:,4),'k:'); M4 = '1.00 mA';

    a5 = plot(ds*integral(:,5),'r:'); M5 = '1.25 mA';
    a6 = plot(ds*integral(:,6),'g:'); M6 = '1.50 mA';
    a7 = plot(ds*integral(:,7),'b--'); M7 = '1.75 mA';
    a8 = plot(ds*integral(:,8),'k--'); M8 = '2.00 mA';

    a9 = plot(ds*integral(:,9),'r:'); M9 = '2.25 mA';
    a10 = plot(ds*integral(:,10),'g:'); M10 = '2.50 mA';
    a11 = plot(ds*integral(:,11),'b:'); M11 = '2.75 mA';
    a12 = plot(ds*integral(:,12),'k:'); M12 = '3.00 mA';

    a13 = plot(ds*integral(:,13),'r:'); M13 = '3.25 mA';
    a14 = plot(ds*integral(:,14),'g--'); M14 = '3.50 mA';
    
    xlabel(['Time [',x_scale,' us]']); ylabel('Charge [nC]');
    title('(b) {\bf Signal integral | Resistive 3kOhm Load | 0.25 - 3.5 mA}')

    
     linkaxes(ha, 'x');  
   
 
    %legend([a1; a2; a3; a4; a5; a6; a7; a8; a9; a10; a11; a12; a13; a14], [M1; M2; M3; M4; M5; M6; M7; M8; M9; M10; M11; M12; M13; M14],'Orientation', 'horizontal');
    
end

%Plot raw data
if do_RAW
    fig2 = figure(3);xlabel(['Time [',x_scale,' \mus]']); ylabel('Current [mA]');
    plot(cut_data)
    title('{\bf Raw Signal}')
end

% estimate RC values
if do_RC_ESTIMATE
    rc_est = zeros(1,n);
    t = 1:n;
    u_scale = 1e-6;
    i_0 = 43; % uA
    C = 1*u_scale; %uF
    R = 57*1e3; %kOhm
    rc_est(:) = i_0*exp(-(t*u_scale)./(R*C));
    rc_est(end)
    tau = R*C % ms
    plot(rc_est)
end

