clc; clear all;close all;

%% FIRST: All files must be saved to data.mat 
load('data');

%% Toggle Processing

do_CUT_DATA = 1;
do_INTEGRATION = 1;
do_SHIFT = 0;
do_SAVE = 1;

%% LOOKUP TABLE
%File# / mA program / plot color

% data(raw_data, File#)

%1  0.25    red
%2  0.5     green
%3  0.75    blue
%4  1.0     black

%5  1.25
%6  1.5
%7  1.75
%8  2

%9  2.25
%10 2.5
%11 2.75
%12 3

%13 3.25
%14 3.5

%% Load
% 3kR + ~0.4kE

%% Sampling
% freq = 1MHz
% res = 12 bit
% samples = 131067


%% Create initial dataset

% data = zeros(131067,14); save('data');
% load('data');
% load('1');
% data(:,1) = double(src1.Data');




%% Cut out single period
% get period from 2mA dataset

if do_CUT_DATA
    nd = 14;
    ts = 1e6;

    [p,initcross,~,nextcross,midlev] = pulseperiod(data(:,8),ts,'MidPct',97);
    initcross = initcross.*ts;
    nextcross = nextcross.*ts;
    % extract middle period
    a = round(initcross(2));
    b = round(nextcross(2));    
    n = length(data((a:b),2));

    % fill new dataset
    cut_data = zeros(n,nd);

    for i = 1:nd
        cut_data(:,i) = data(a:b,i);
    end

end


%% Shift data
if do_SHIFT
    SHIFT_US = 520;
    cut_data = circshift(cut_data,SHIFT_US);
end


%% Integration

if do_INTEGRATION
    integral = zeros(n,nd);

    for j = 1:nd
        for i = 1:n
            integral(i,j) = sum(cut_data((1:i),j));
        end
    end

    plot(integral)
end

%% Plots
plot(cut_data)



%% Save new datasets

if do_SAVE
    % save('data.mat','data','-append');
     save('data.mat','cut_data','-append');
     save('data.mat','integral','-append');
    % save('data.mat','n','-append');
    % save('data.mat','nd','-append');
end








